# nmbd

## Samba

## 23 Oct 1998

## NAME

nmbd - NetBIOS name server to provide NetBIOS over IP naming services to clients

## SYNOPSIS

nmbd [-D] [-a] [-o] [-h] [-V] [-H lmhosts file] [-d debuglevel] [-l log file basename] [-n primary NetBIOS name] [-p port number] [-s configuration file]

## DESCRIPTION

This program is part of the Samba suite.

nmbd is a server that understands and can reply to NetBIOS over IP name service requests, like those produced by SMBD/CIFS clients such as Windows 95/98, Windows NT and LanManager clients. It also participates in the browsing protocols which make up the Windows "Network Neighborhood" view.

SMB/CIFS clients, when they start up, may wish to locate an SMB/CIFS server. That is, they wish to know what IP number a specified host is using.

Amongst other services, nmbd will listen for such requests, and if its own NetBIOS name is specified it will respond with the IP number of the host it is running on. Its "own NetBIOS name" is by default the primary DNS name of the host it is running on, but this can be overridden with the -n option (see OPTIONS below). Thus nmbd will reply to broadcast queries for its own name(s). Additional names for nmbd to respond on can be set via parameters in the smb.conf(5) configuration file.

nmbd can also be used as a WINS (Windows Internet Name Server) server. What this basically means is that it will act as a WINS database server, creating a database from name registration requests that it receives and replying to queries from clients for these names.

In addition, nmbd can act as a WINS proxy, relaying broadcast queries from clients that do not understand how to talk the WINS protocol to a WIN server.

## OPTIONS

-D
  If specified, this parameter causes nmbd to operate as a daemon. That is, it detaches itself and runs in the background, fielding requests on the appropriate port. By default, nmbd will NOT operate as a daemon. nmbd can also be operated from the inetd meta-daemon, although this is not recommended.

-a
  If this parameter is specified, each new connection will append log messages to the log file. This is the default.

-o
  If this parameter is specified, the log files will be overwritten when opened. By default, the log files will be appended to.

-h
  Prints the help information (usage) for nmbd.

-V
  Prints the version number for nmbd.

-H filename
  NetBIOS lmhosts file.

  The lmhosts file is a list of NetBIOS names to IP addresses that is loaded by the nmbd server and used via the name resolution mechanism name resolve order described in smb.conf (5) to resolve any NetBIOS name queries needed by the server. Note that the contents of this file are NOT used by nmbd to answer any name queries. Adding a line to this file affects name NetBIOS resolution from this host ONLY.

  The default path to this file is compiled into Samba as part of the build process. Common defaults are /usr/local/samba/lib/lmhosts, /usr/samba/lib/lmhosts or /etc/lmhosts. See the lmhosts (5) man page for details on the contents of this file.

-d debuglevel
  debuglevel is an integer from 0 to 10.

  The default value if this parameter is not specified is zero.

  The higher this value, the more detail will be logged to the log files about the activities of the server. At level 0, only critical errors and serious warnings will be logged. Level 1 is a reasonable level for day to day running - it generates a small amount of information about operations carried out.

  Levels above 1 will generate considerable amounts of log data, and should only be used when investigating a problem. Levels above 3 are designed for use only by developers and generate HUGE amounts of log data, most of which is extremely cryptic.

  Note that specifying this parameter here will override the log level parameter in the smb.conf (5) file.

-l logfile
  The -l parameter specifies a path and base filename into which operational data from the running nmbd server will be logged. The actual log file name is generated by appending the extension ".nmb" to the specified base name. For example, if the name specified was "log" then the file log.nmb would contain the debugging data.

  The default log file path is compiled into Samba as part of the build process. Common defaults are /usr/local/samba/var/log.nmb, /usr/samba/var/log.nmb or /var/log/log.nmb.

-n primary NetBIOS name
  This option allows you to override the NetBIOS name that Samba uses for itself. This is identical to setting the NetBIOS name parameter in the smb.conf file but will override the setting in the smb.conf file.

-p UDP port number
  UDP port number is a positive integer value.

  This option changes the default UDP port number (normally 137) that nmbd responds to name queries on. Don't use this option unless you are an expert, in which case you won't need help!

-s configuration file
  The default configuration file name is set at build time, typically as /usr/local/samba/lib/smb.conf, but this may be changed when Samba is autoconfigured.

  The file specified contains the configuration details required by the server. See smb.conf (5) for more information.

## FILES

/etc/inetd.conf

If the server is to be run by the inetd meta-daemon, this file must contain suitable startup information for the meta-daemon.

/etc/rc

(or whatever initialization script your system uses).

If running the server as a daemon at startup, this file will need to contain an appropriate startup sequence for the server.

/usr/local/samba/lib/smb.conf

This is the default location of the smb.conf server configuration file. Other common places that systems install this file are /usr/samba/lib/smb.conf and /etc/smb.conf.

When run as a WINS server (see the wins support parameter in the smb.conf (5) man page), nmbd will store the WINS database in the file `wins.dat` in the `var/locks` directory configured under wherever Samba was configured to install itself.

If nmbd is acting as a browse master (see the local master parameter in the smb.conf (5) man page), nmbd will store the browsing database in the file `browse.dat` in the `var/locks` directory configured under wherever Samba was configured to install itself.

## SIGNALS

To shut down an nmbd process it is recommended that SIGKILL (-9) NOT be used, except as a last resort, as this may leave the name database in an inconsistent state. The correct way to terminate nmbd is to send it a SIGTERM (-15) signal and wait for it to die on its own.

nmbd will accept SIGHUP, which will cause it to dump out it's namelists into the file `namelist.debug` in the /usr/local/samba/var/locks directory (or the var/locks directory configured under wherever Samba was configured to install itself). This will also cause nmbd to dump out it's server database in the log.nmb file. In addition, the debug log level of nmbd may be raised by sending it a SIGUSR1 (`kill -USR1 <nmbd-pid>`) and lowered by sending it a SIGUSR2 (`kill -USR2 <nmbd-pid>`). This is to allow transient problems to be diagnosed, whilst still running at a normally low log level.

## VERSION

This man page is correct for version 2.0 of the Samba suite.

## SEE ALSO

inetd (8), smbd (8), smb.conf (5), smbclient (1), testparm (1), testprns (1), and the Internet RFC's rfc1001.txt, rfc1002.txt. In addition the CIFS (formerly SMB) specification is available as a link from the Web page : http://samba.org/cifs/.

## AUTHOR

The original Samba software and related utilities were created by Andrew Tridgell samba@samba.org. Samba is now developed by the Samba Team as an Open Source project similar to the way the Linux kernel is developed.

The original Samba man pages were written by Karl Auer. The man page sources were converted to YODL format (another excellent piece of Open Source software, available at ftp://ftp.icce.rug.nl/pub/unix/) and updated for the Samba2.0 release by Jeremy Allison. samba@samba.org.

See samba (7) to find out how to get a full list of contributors and details on how to submit bug reports, comments etc.